#!/bin/bash

# Check if the file argument is provided
if [ $# -eq 0 ]; then
  echo "Usage: $0 <filename>"
  exit 1
fi

# Read the timestamps from the file into an array
readarray -t timestamps < "$1"

# Loop through each timestamp and extract the hour part
hours=()
for timestamp in "${timestamps[@]}"; do
  hour=$(date -d "$timestamp" +"%H")
  hours+=("$hour")
done

# Count the occurrences of each hour
declare -A counts
for hour in "${hours[@]}"; do
  (( counts[$hour]++ ))
done

# Print the histogram
for hour in "${!counts[@]}"; do
  printf "%02d: %s\n" "$hour" "$(printf '#%.0s' {1..${counts[$hour]}})"
done
